#ifndef CTRL_MODULE_H
#define CTRL_MODULE_H

#include "xil_io.h"
#include "define.h"
#include "main.h"
#include "tcp_client.h"



static u32_t g_cCMProcessIdx;				//	CtrlModuleProcess   ó ε

u32_t g_nMastCurrHeight;					//	Ʈ  (0 ~ 570cm)
u8_t g_cMastRcvCmd;							//	   (Bit0:, Bit1:ϰ, Bit2:ӻ, Bit3:ִ, Bit4: ִȮ, Bit5: Է)
static u8_t g_cMastAction;					//	FPGA  Ʈ   (Stop, Up, Down: 0x00, 0x01, 0x02)
u8_t g_cBitDetail;							//	BIT Detail 

u32_t g_nSetMastHeight;						//	Ʈ ǥ 
static u8_t g_cRmtConn;						//	  

u8_t g_cMastPeriodSendCmd;					//	DeviceStart_Request  Ŀǵ, ̿ó: AntMastStatus_Report(UDP), AntMastCBIT_Report,   Ȱ/Ȱ
u8_t g_cDeviceErase;						//	DeviceErase 
static u8_t g_cMastPowerCtrlRcvCmd;			//	DevicePower_Reqeust  Ŀǵ, 0x05: Off غ, 0x06:  Off, 0x01:  Off , 0x07:  On
u8_t g_cCmdPreparePowerOff;					//	DevicePower_Request  , 1: Set, 0: Reset			0x05:  Off غ,	0x01:  Off 
u8_t g_cCmdPowerOff;						//  DevicePower_Request  , 1: Set, 0: Reset			0x06:  Off,			0x07:  On
u32_t g_nEncoderMT;							//	ڴ Ƽϰ X, ڴ ü(24.09.10)
static u8_t g_cEncoderSaveFlag;				//	ڴ Ƽϰ    0: , 1: 
u8_t g_cMotorLedFlickerCnt;					//	 LED  ī

u32_t g_nCnt2;								//	   ó ī
u32_t g_nEcdeepromCnt;						//	ڴ Ƽ eeprom Ͽ ī

u32_t g_nBitDetailHBCnt;					//	ӹó Heart Beat ŵǴ Ǵϴ ī(BIT Detail ӹó  ° )
u8_t g_cBitDetailHBErr;						//	Heart Beat  Off 
u8_t g_cOverCurrFlag;						//	 ߻ 
u8_t g_cEncoderErrFlag;						//	ڴ  ġ 
u8_t g_cEncoderHWResetFlag;					//	ڴ   (PBA  Set Origin)

static u8_t GetBit(u8_t nIdx, u8_t cMask, u8_t cShift);			//	 BIT 
static void SetBit(u8_t nIdx, u8_t cMask, u8_t cShift);			//	 BIT ϱ
static u32_t GetByte(u8_t nIdx);								//	 byte 
static void SetByte(u8_t nIdx, u8_t cData);						//	 byte ϱ

static void CheckOverCurrent(void);								//	  Ȯ
static void CheckEncoder(void);									//	ڴ  ġ Ȯ
static void CheckBitDetailInfo(void);							//	BIT Detail  Ȯ
static void CheckCurrHeight(void);								//	̰ Ȯ

void SetMotor(u8_t cCmd);										//	Ʈ  (Stop, Up, Down: 0x00, 0x01, 0x02)
static void SetLEDControl(void);								//	LED  (˶, Ʈ )

static void SetEncoderMT(void);									//	Ʈ ڴ Ƽϰ 

void InitCtrlModule(void);										//	  ʱ 
void CtrlModuleProcess(void);									//	   ó


#endif // CTRL_MODULE_H
