#ifndef TCP_CLIENT_H
#define TCP_CLIENT_H

#include "lwipopts.h"
#include "lwip/ip_addr.h"
#include "lwip/err.h"
#include "lwip/tcp.h"
#include "lwip/inet.h"
#include "xil_printf.h"
#include "eeprom.h"
#include "define.h"
#include "main.h"
#include "ctrl_module.h"

struct TcpCliConnectPcb
{
	u8_t cConnected;									//	  Ȯ, false   õ
	struct tcp_pcb *pcb;								//	tcp_pcb
	u8_t szRecvData[NUM_RECV_BUF];						//	 
	u32_t nRecvLen;										//	  
	u8_t cRecvFlag;										//	 ÷
	u8_t cIsConnecting;									//	 õ  
};


struct TcpCliConnectPcb g_stTcpClientMy;				//	 ӿ Ŭ̾Ʈ
static ip_addr_t g_ipaddrMP;							//	ӹó TCP Server IP
static u8_t m_nConDelayCnt;

static u32_t m_nConnectCnt;
u32_t g_nTcpCliConCnt;									//	TCP Client      õ ī

u32_t g_nTcpDisconnectCnt;								//	  ӹó S/W Heart Beat ̼ 5 ̻ ߻ Ȯο ī
u32_t g_nTcpDisconnectChk;								//	  ӹóS/W Heart Beat   5 ̻ Ǹ 

void InitTcpClient(void);								//	TCP Client ʱȭ
static void tcp_client_connect(void);					//	TCP  
void ConnectToTcpServer(void);							//	TCP  ݺ  
static err_t tcp_client_connected(void *arg, struct tcp_pcb *tpcb, err_t err);	//	connect ݹ Լ
static err_t tcp_client_recv(void *arg, struct tcp_pcb *tpcb, struct pbuf *p, err_t err);			//	 ݹ Լ
static err_t tcp_client_sent(void *arg, struct tcp_pcb *tpcb, u16_t len);											//	ACK  ݹ Լ
static err_t tcp_client_poll(void *arg, struct tcp_pcb *tpcb);																//	poll ݹ Լ
void tcp_client_connection_close(struct tcp_pcb* tpcb);					//	client socket  ó

#endif
