#include "tcpipcomm.h"
#include "ctrl_module.h"


//	ڿ (strncmp null   Ǵ κ Ȱ)
static u8_t strCompare(const u8_t *str1, const u8_t *str2, u8_t str2Len)
{
	u8_t i, cVal = 1;
	
	if(str2Len < 10u)
	{
		for(i = 0u ; i < str2Len ; i++)
		{
			if(str1[i] != str2[i])
			{
				cVal = 0;					//	ġ 
			}
		}
	}

	return cVal;							//	ġ
}

//	ڿ  ʱȭ		ó ȿ Ŷ ĺ
void InitCompareMember(void)
{
	szCase[0][0] = IDC_CMD_TYPE_DEVICE_PBIT;	szCase[0][1] = 0x20u;	szCase[0][2] = 0x40u;	//	DevicePBIT_Request		PBIT û
	szCase[1][0] = IDC_CMD_TYPE_BIT_DETAIL;		szCase[1][1] = 0x20u;	szCase[1][2] = 0x40u;	//	DeviceBITdetail_Request	ġ  BIT û
	szCase[2][0] = IDC_CMD_TYPE_MAST_CONTROL;	szCase[2][1] = 0x23u;	szCase[2][2] = 0x40u;	//	AntMastControl_Request	׳Ʈ    û
	szCase[3][0] = IDC_CMD_TYPE_DEVICE_ERASE;	szCase[3][1] = 0x20u;	szCase[3][2] = 0x40u;	//	DeviceErase_Request		ġ Ұ û
	szCase[4][0] = IDC_CMD_TYPE_DEVICE_POWER;	szCase[4][1] = 0x21u;	szCase[4][2] = 0x40u;	//	DevicePower_Request		ġ  û
	szCase[5][0] = 0xFFu;	szCase[5][1] = 0xFEu;	szCase[5][2] = 0x40u;		//	SimAlarm_Set			 ˸ 
	szCase[6][0] = 0xFFu;	szCase[6][1] = 0xFDu;	szCase[6][2] = 0x40u;		//	MastOrigin_Set			 ˸ 

}

//	TCP Client   ۽ ó
void TcpClientCommProceess(void)
{
	u32_t j, nLen = 0;

	if((g_stTcpClientMy.cConnected == TRUE) && (g_stTcpClientMy.cRecvFlag == TRUE))		//	ӵ pcb  Ŷ   Ȯ
	{
		g_stTcpClientMy.cRecvFlag = FALSE;			//  ÷ 

#if TEST_LOG_ON

		xil_printf("rec msg:");
		for(j = 0 ; j < g_stTcpClientMy.nRecvLen ; j++)
		{
			xil_printf("%02X", (u32_t)g_stTcpClientMy.szRecvData[j]);
		}
		xil_printf(" [%d]\r\n", g_stTcpClientMy.nRecvLen);
#endif

		while(g_stTcpClientMy.nRecvLen >= (u32_t)MIN_TCP_SER_RCV_LEN)															//	ϼ Ŷ ּ  ũų    ó
		{
			if(strCompare((const u8_t*)szCase[0], (const u8_t*)g_stTcpClientMy.szRecvData, (u8_t)LEN_COMPARE) == 1u)			//	01. DevicePBIT_Request		ġ PBIT û
			{
				nLen = LEN_DEVICE_PBIT_REQ;
				g_cMastPeriodSendCmd = TCP_CMD_PERIOD_REPORT_START;																//	1ȸ    (  )

				FuncAntMastPBITRes((const u8_t *)g_stTcpClientMy.szRecvData);													//	01. AntMastPBIT_Response  ó
			}
			else if(strCompare((const u8_t*)szCase[1], (const u8_t*)g_stTcpClientMy.szRecvData, (u8_t)LEN_COMPARE) == 1u)		//	02. DeviceBITdetail_Request	ġ  BIT û
			{
				nLen = LEN_DEVICE_BIT_DETAIL_REQ;

				if((g_stTcpClientMy.szRecvData[11] == 0x40u) && (g_stTcpClientMy.szRecvData[12] == 0x00u))						//	ġ Ȯ 0x0040(B/E)  0x4000(L/E)   Device(2Byte) 0x0040(Bit6 High)
				{
					FuncAntMastBITdetailRes((const u8_t *)g_stTcpClientMy.szRecvData);											//	02. AntMastBITdetail_Response  ó
				}
			}
			else if(strCompare((const u8_t*)szCase[2], (const u8_t*)g_stTcpClientMy.szRecvData, (u8_t)LEN_COMPARE) == 1u)		//	03. AntMastControl_Request	׳Ʈ    û
			{
				nLen = LEN_ANT_MAST_CONTROL_REQ;

				g_cOverCurrFlag = 0u;

				g_cMastRcvCmd = g_stTcpClientMy.szRecvData[10];																	//	Control(1) 0x11:  Է, 0x10:  , 0x01:  ϰ, 0x00: 

				if(g_cMastRcvCmd == (u8_t)CMD_MOTOR_USER_INPUT)																	//	 Է° ִ 
				{
					nLen += (u32_t)4;																							//	ű 
					g_nSetMastHeight = (u32_t)g_stTcpClientMy.szRecvData[14] << 24;												// Little Endian  Big Endian
					g_nSetMastHeight += (u32_t)g_stTcpClientMy.szRecvData[13] << 16;
					g_nSetMastHeight += (u32_t)g_stTcpClientMy.szRecvData[12] << 8;
					g_nSetMastHeight += g_stTcpClientMy.szRecvData[11];															//	ǥ ̰ 
#if DEBUG_CTRL_MODULE
					xil_printf("g_nSetMastHeight:%d\r\n", (u32_t)g_nSetMastHeight);
#endif
				}
				else
				{
					g_nSetMastHeight = 0;
				}
		
				SetMotor(g_cMastRcvCmd);																						//	Motor Up/Down/Stop  

				FuncAntMastControlRes((const u8_t *)g_stTcpClientMy.szRecvData);												//	03. AntMastControl_Response  ó
			}
			else if(strCompare((const u8_t*)szCase[4], (const u8_t*)g_stTcpClientMy.szRecvData, (u8_t)LEN_COMPARE) == 1u)		//	05. DevicePower_Request ġ  û
			{
				nLen = LEN_DEVICE_POWER_REQ;

				if(g_stTcpClientMy.szRecvData[11] == 0xA0u)																		//	Unit Ȯ, 0xA0:׳Ʈ
				{
					FuncAntMastPowerRes((const u8_t *)g_stTcpClientMy.szRecvData);												//	05. AntMastPower_Response  ó
				}
			}
			else
			{
				g_stTcpClientMy.nRecvLen = 0;		//	while loop   ó
			}

			if(nLen > 0u)
			{
				g_stTcpClientMy.nRecvLen -= nLen;																				//	  
				(void)memcpy((void*)&g_stTcpClientMy.szRecvData[0], (const void*)(&g_stTcpClientMy.szRecvData[nLen]), (size_t)g_stTcpClientMy.nRecvLen);	//	 Ŷ 
			}
			nLen = 0;
		}

		(void)memset((void *)g_stTcpClientMy.szRecvData, (s32_t)0, (s32_t)NUM_RECV_BUF);										//	 Ŷ ִٸ 
		g_stTcpClientMy.nRecvLen = 0;
	}
}

//	01.AntMastPBIT_Response  ó
static void FuncAntMastPBITRes(const uint8_t *pszData)
{
	u32_t i = 0, j;
	u8_t szBuf[LEN_DEVICE_PBIT_REQ + 2 + ARR_BUF_MARGIN];
	u8_t cData = 0;

	(void)memset((void *)szBuf, (s32_t)0, (s32_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_DEVICE_PBIT;	//	Type
	szBuf[i++] = 0x35u;						//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;			//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;			//	Dest
	szBuf[i++] = (u8_t)g_cSn;				//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = ICD_CMD_TM_TCP;			//	TM
	szBuf[i++] = 0x02u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length

	if(g_cEncoderErrFlag == 1u)				//	ڴ 
	{
		szBuf[i++] = 0x0Au;					//	Function	׳Ʈ Ȯ/ 0x02,  0x08 = 00001010b = 0x0A
		szBuf[i++] = 0x05u;					//	Device		׳Ʈ Bit0: 1,  Bit1: 0, Ϻ Bit2: 1 = 0x05
	}
	else
	{
		szBuf[i++] = 0x00u;
		szBuf[i++] = 0x00u;
	}

	struct pbuf *p = NULL;
	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		p->payload = szBuf;
		p->len = (u16_t)i;
		(void)tcp_write((struct tcp_pcb*)g_stTcpClientMy.pcb, (const void*)p->payload, (u16_t)p->len, (u8_t)1);
		(void)pbuf_free(p);
	}
	szBuf[0] = pszData[0];
}

//	02.AntMastBITdetail_Response  ó
static void FuncAntMastBITdetailRes(const uint8_t *pszData)
{
	u32_t i = 0, j;
	u8_t szBuf[LEN_DEVICE_BIT_DETAIL_REQ + 1 + ARR_BUF_MARGIN];

	(void)memset((void *)szBuf, (s32_t)0, (s32_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_BIT_DETAIL;	//	Type
	szBuf[i++] = 0x35u;						//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;			//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;			//	Dest
	szBuf[i++] = (u8_t)g_cSn;				//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = ICD_CMD_TM_TCP;			//	TM
	szBuf[i++] = 0x02u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length

	szBuf[i++] = pszData[10];				//	0x00(PBIT), 0x40(CBIT)

	szBuf[i++] = g_cBitDetail;				//	BIT Detail Bit 3 : Ͱ Bit 2 : ̰ ǥÿ ڴ üũ, Bit 1 : Ʈ  üũ, Bit 0 : ׳Ʈ-ӹ   ̹߻(0)/߻(1)

	struct pbuf *p = NULL;
	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		p->payload = szBuf;
		p->len = (u16_t)i;
		(void)tcp_write((struct tcp_pcb*)g_stTcpClientMy.pcb, (const void*)p->payload, (u16_t)p->len, (u8_t)1);
		(void)pbuf_free(p);
	}
	szBuf[0] = pszData[0];
}

//	03.AntMastControl_Response  ó
static void FuncAntMastControlRes(const uint8_t *pszData)
{
	u32_t i = 0, j;
	u8_t szBuf[LEN_ANT_MAST_CONTROL_REQ + 4 + ARR_BUF_MARGIN];

	(void)memset((void *)szBuf, (s32_t)0, (s32_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_MAST_CONTROL;						//	Type
	szBuf[i++] = 0x33u;											//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;								//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;								//	Dest
	szBuf[i++] = (u8_t)g_cSn;									//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = ICD_CMD_TM_TCP;								//	TM
	if(g_cMastRcvCmd != (u8_t)CMD_MOTOR_USER_INPUT)				//	 Է°  
	{
		szBuf[i++] = 0x01u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = g_cMastRcvCmd;								//	Control(1) 0xC0:  Է, 0x80:  , 0x40:  ϰ, 0x00: 
	}
	else
	{
		szBuf[i++] = 0x05u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = 0x00u;										//	Length
		szBuf[i++] = g_cMastRcvCmd;								//	Control(1) 0xC0:  Է, 0x80:  , 0x40:  ϰ, 0x00: 

		szBuf[i++] = (u8_t)g_nSetMastHeight & 0xFFu;			//	Little Endian ó,  ̰ Է
		szBuf[i++] = (u8_t)(g_nSetMastHeight >> 8) & 0xFFu;
		szBuf[i++] = (u8_t)(g_nSetMastHeight >> 16) & 0xFFu;
		szBuf[i++] = (u8_t)(g_nSetMastHeight >> 24) & 0xFFu;
	}

	struct pbuf *p = NULL;
	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	/* MISRA C Dir 4.11 : ۽  ȿ ˻*/
	if(p != NULL)
	{
		p->payload = szBuf;
		p->len = (u16_t)i;
		(void)tcp_write((struct tcp_pcb*)g_stTcpClientMy.pcb, (const void*)p->payload, (u16_t)p->len, (u8_t)1);
		(void)pbuf_free(p);
	}
	szBuf[0] = pszData[0];
}

//	05. AntMastPower_Response  ó
static void FuncAntMastPowerRes(const uint8_t *pszData)
{
	u32_t i = 0, j;
	u8_t szBuf[LEN_DEVICE_POWER_REQ + ARR_BUF_MARGIN];

	(void)memset((void *)szBuf, (s32_t)0, (s32_t)(sizeof(szBuf)));

	szBuf[i++] = IDC_CMD_TYPE_DEVICE_POWER;	//	Type
	szBuf[i++] = 0x31u;						//	ID
	szBuf[i++] = ICD_CMD_UNIT_MP;			//	Sour
	szBuf[i++] = ICD_CMD_UNIT_MAST;			//	Dest
	szBuf[i++] = (u8_t)g_cSn;				//	SN
	g_cSn += (u8_t)1;
	szBuf[i++] = ICD_CMD_TM_TCP;			//	TM
	szBuf[i++] = 0x01u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = 0x00u;						//	Length
	szBuf[i++] = pszData[10];				//	Control 1Byte

	struct pbuf *p = NULL;
	p = pbuf_alloc(PBUF_TRANSPORT, (u16_t)i, PBUF_POOL);
	if(p != NULL)
	{
		p->payload = (void*)szBuf;
		p->len = (u16_t)i;
		(void)tcp_write((struct tcp_pcb*)g_stTcpClientMy.pcb, (const void*)p->payload, (u16_t)p->len, (u8_t)1u);
		(void)pbuf_free(p);
	}
	szBuf[0] = pszData[0];
}
