#ifndef UDP_CLIENT_H
#define UDP_CLIENT_H

#include "lwipopts.h"
#include "xlwipconfig.h"
#include "lwip/ip_addr.h"
#include "lwip/err.h"
#include "lwip/udp.h"
#include "lwip/inet.h"
#include "xil_printf.h"
#include "platform.h"
#include <sleep.h>
#include "ctrl_module.h"
#include "tcpipcomm.h"

#include "define.h"

struct ClientUdpPcb
{
	struct udp_pcb *pcb;					//	udp_pcb
	u8_t szRecvData[NUM_RECV_BUF];			//	 
	u32_t nRecvLen;							//	  
	u8_t cRecvFlag;							//	 ÷
} ;

static struct ClientUdpPcb g_stUdpCliPcb;			//	UDP ϴ Ŭ̾Ʈ ó

u32_t g_nReportCnt;									//	udp_client , static ϸ ȵ

static u16_t g_unUdpServerPort;						//	UDP Server Port
static u8_t m_cReportIdx = 0;						//	Report 2  ۽ſ
static u8_t m_cRecvHBFromMP = 0;					//	ӹóκ Heart Beat  


void InitUdpServer(void);
static void udp_server_receive_callback(void *arg, struct udp_pcb *upcb, struct pbuf *p, ip_addr_t *addr, u16_t port);

static void InitUdpClientMember(void);				//	UDP Client ü ʱȭ
void UdpCommProcess(void);							//	UDP  ó
static void UdpCommPeriod(void);					//	UDP ֱ  ó

static void FuncAntMastStatusReport(void);			//	׳ Ʈ   ۽
static void FuncAntMastCBitReport(void);			//	׳ Ʈ CBIT  ۽
static void FuncHeartBeatData(void);				//	LAN Ἲ Ȯ 

#endif	//	UDP_CLIENT_H
